//+----------------------------------------------------------------------+
//|                                                  how_volatile2.4.mq4 +
//| Shows current and 3 previous bars' height and the average bar height +
//|        and price change and range relative to current price for four +
//|      selectable bar ranges. Bar height and price change/range may be +
//|separately assigned three colours for ranges of value to aid analysis.+
//|                                                      www.efex.org.uk +
//+----------------------------------------------------------------------+
#property indicator_chart_window

extern int     Period.1 = 2;
extern int     Period.2 = 3;
extern int     Period.3 = 5;
extern int     Period.4 = 8;
extern int     Period.5 = 13;


extern bool    AutoMultiplier = true;
extern int     Multiplier = 10000;

extern string  Comment.1 =       "Position of output text";
extern string  Comment.2 =       "0=Top Left, 1=Top Right";
extern string  Comment.3 =       "2=Bottom Left, 3=Bottom Right";
extern int     Corner.Of.Chart = 2;

extern int     Font.size = 14;
extern color   Font.colour = White;
extern int     Range.High = 25;
extern int     Range.Low = 10;
extern color   Range.High.Colour = Green;
extern color   Range.Mid.Colour = Orange;
extern color   Range.Low.Colour = Red;

extern color   Change.Up.Colour = DodgerBlue;
extern color   Change.None.Colour = Tan;
extern color   Change.Down.Colour = Magenta;

color          Change.Colour = White;
color          Range.Colour = White;

int   Time.Frame = 0,ShiftX=0;

int start()
   {
      string number = DoubleToStr(Ask,2);
      if (AutoMultiplier == true){
         if (StringFind(number,".",0) == 3)Multiplier=100;
         if (StringFind(number,".",0) == 2)Multiplier=1000;
         if (StringFind(number,".",0) == 1)Multiplier=10000;
       }   
      ShiftX=(Font.size*8);
      int i;
      int Range.Current=0,Range.Previous=0,Range.Previous1=0,Range.Previous2=0,Range.Previous3=0,Range.1=0,Range.2=0,Range.3=0,Range.4=0,Range.5=0;
      int Move.1=0,Move.2=0,Move.3=0,Move.4=0, Move.5=0;
      int Range.Period.1=0,Range.Period.2=0,Range.Period.3=0,Range.Period.4=0,Range.Period.5=0;
      int Median.Current=(iHigh(NULL,Time.Frame,0)+iLow(NULL,Time.Frame,0))/2*Multiplier;
      int Median.1=(iHigh(NULL,Time.Frame,Period.1)+iLow(NULL,Time.Frame,Period.1))/2*Multiplier;
      int Median.2=(iHigh(NULL,Time.Frame,Period.2)+iLow(NULL,Time.Frame,Period.2))/2*Multiplier;      
      int Median.3=(iHigh(NULL,Time.Frame,Period.3)+iLow(NULL,Time.Frame,Period.3))/2*Multiplier;      
      int Median.4=(iHigh(NULL,Time.Frame,Period.4)+iLow(NULL,Time.Frame,Period.4))/2*Multiplier;
      int Median.5=(iHigh(NULL,Time.Frame,Period.5)+iLow(NULL,Time.Frame,Period.5))/2*Multiplier;
      int Range.Day = (iHigh(NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0))*Multiplier;
      int Range.Yesterday = (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))*Multiplier;
      Range.Current = (iHigh(NULL,Time.Frame,0)-iLow(NULL,Time.Frame,0))*Multiplier;
      Range.Previous = (iHigh(NULL,Time.Frame,1)-iLow(NULL,Time.Frame,1))*Multiplier;
      Range.Previous1 = (iHigh(NULL,Time.Frame,2)-iLow(NULL,Time.Frame,2))*Multiplier;      
      Range.Previous2 = (iHigh(NULL,Time.Frame,3)-iLow(NULL,Time.Frame,3))*Multiplier;
      Range.Previous3 = (iHigh(NULL,Time.Frame,4)-iLow(NULL,Time.Frame,4))*Multiplier;      
      Range.Period.1=(iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Period.1,0))-iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Period.1,0)))*Multiplier;
      Range.Period.2=(iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Period.2,0))-iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Period.2,0)))*Multiplier;
      Range.Period.3=(iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Period.3,0))-iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Period.3,0)))*Multiplier;
      Range.Period.4=(iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Period.4,0))-iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Period.4,0)))*Multiplier;
      Range.Period.5=(iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Period.5,0))-iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Period.5,0)))*Multiplier;
      for(i=1;i<=Period.1;i++) Range.1 = Range.1 + (iHigh(NULL,Time.Frame,i)-iLow(NULL,Time.Frame,i))*Multiplier;
      for(i=1;i<=Period.2;i++) Range.2 = Range.2+ (iHigh(NULL,Time.Frame,i)-iLow(NULL,Time.Frame,i))*Multiplier;
      for(i=1;i<=Period.3;i++) Range.3 = Range.3 + (iHigh(NULL,Time.Frame,i)-iLow(NULL,Time.Frame,i))*Multiplier;
      for(i=1;i<=Period.4;i++)Range.4 = Range.4 + (iHigh(NULL,Time.Frame,i)-iLow(NULL,Time.Frame,i))*Multiplier;    
      for(i=1;i<=Period.5;i++)Range.5 = Range.5 + (iHigh(NULL,Time.Frame,i)-iLow(NULL,Time.Frame,i))*Multiplier;  
      Move.1 = Median.Current-Median.1;
      Move.2 = Median.Current-Median.2;
      Move.3 = Median.Current-Median.3;
      Move.4 = Median.Current-Median.4;
      Move.5 = Median.Current-Median.5;
      Range.1 = Range.1/Period.1;
      Range.2 = Range.2/Period.2;
      Range.3 = Range.3/Period.3;
      Range.4 = Range.4/Period.4;
      Range.5 = Range.5/Period.5;
      string tLine="Range Today="+Range.Day+", Yesterday="+Range.Yesterday;
      string tLinecurrentandprevious="Current & last 4 bars: ";
      string tLineP="Number of bars back:";
      string tLine1="Average bar since:";
      string tLine2="Price change since:";
      string tLine3="Price range since:";

      ObjectCreate("DayRanges",OBJ_LABEL,0,0,0);
      ObjectSetText("DayRanges",tLine,Font.size-4,"Verdana",Font.colour);
      ObjectSet("DayRanges",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("DayRanges",OBJPROP_XDISTANCE,5);
      ObjectSet("DayRanges",OBJPROP_YDISTANCE,35+Font.size*5);
      
      ObjectCreate("Current&P",OBJ_LABEL,0,0,0);
      ObjectSetText("Current&P",tLinecurrentandprevious,Font.size,"Verdana",Font.colour);
      ObjectSet("Current&P",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Current&P",OBJPROP_XDISTANCE,5);
      ObjectSet("Current&P",OBJPROP_YDISTANCE,30+Font.size*4);

      if (Range.Current >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Current <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("CurrentRange",OBJ_LABEL,0,0,0);
      ObjectSetText("CurrentRange",DoubleToStr(Range.Current,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("CurrentRange",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("CurrentRange",OBJPROP_XDISTANCE,110+ShiftX);
      ObjectSet("CurrentRange",OBJPROP_YDISTANCE,30+Font.size*4);      
      
      if (Range.Previous >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Previous <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("PreviousRange",OBJ_LABEL,0,0,0);
      ObjectSetText("PreviousRange",DoubleToStr(Range.Previous,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("PreviousRange",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("PreviousRange",OBJPROP_XDISTANCE,150+ShiftX);
      ObjectSet("PreviousRange",OBJPROP_YDISTANCE,30+Font.size*4);
            
      if (Range.Previous1 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Previous1 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("PreviousRange1",OBJ_LABEL,0,0,0);
      ObjectSetText("PreviousRange1",DoubleToStr(Range.Previous1,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("PreviousRange1",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("PreviousRange1",OBJPROP_XDISTANCE,190+ShiftX);
      ObjectSet("PreviousRange1",OBJPROP_YDISTANCE,30+Font.size*4);
      
      if (Range.Previous2 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Previous2 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("PreviousRange2",OBJ_LABEL,0,0,0);
      ObjectSetText("PreviousRange2",DoubleToStr(Range.Previous2,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("PreviousRange2",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("PreviousRange2",OBJPROP_XDISTANCE,230+ShiftX);
      ObjectSet("PreviousRange2",OBJPROP_YDISTANCE,30+Font.size*4);
      
      if (Range.Previous3 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Previous3 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      

      ObjectCreate("PreviousRange3",OBJ_LABEL,0,0,0);
      ObjectSetText("PreviousRange3",DoubleToStr(Range.Previous3,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("PreviousRange3",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("PreviousRange3",OBJPROP_XDISTANCE,270+ShiftX);
      ObjectSet("PreviousRange3",OBJPROP_YDISTANCE,30+Font.size*4);
            
      ObjectCreate("Periods",OBJ_LABEL,0,0,0);
      ObjectSetText("Periods",tLineP,Font.size,"Verdana",Font.colour);
      ObjectSet("Periods",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Periods",OBJPROP_XDISTANCE,5);
      ObjectSet("Periods",OBJPROP_YDISTANCE,25+Font.size*3);
      
      ObjectCreate("Period.1",OBJ_LABEL,0,0,0);
      ObjectSetText("Period.1",DoubleToStr(Period.1,0),Font.size,"Verdana",Font.colour);
      ObjectSet("Period.1",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Period.1",OBJPROP_XDISTANCE,110+ShiftX);
      ObjectSet("Period.1",OBJPROP_YDISTANCE,25+Font.size*3);      

      ObjectCreate("Period.2",OBJ_LABEL,0,0,0);
      ObjectSetText("Period.2",DoubleToStr(Period.2,0),Font.size,"Verdana",Font.colour);
      ObjectSet("Period.2",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Period.2",OBJPROP_XDISTANCE,150+ShiftX);
      ObjectSet("Period.2",OBJPROP_YDISTANCE,25+Font.size*3);                        

      ObjectCreate("Period.3",OBJ_LABEL,0,0,0);
      ObjectSetText("Period.3",DoubleToStr(Period.3,0),Font.size,"Verdana",Font.colour);
      ObjectSet("Period.3",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Period.3",OBJPROP_XDISTANCE,190+ShiftX);
      ObjectSet("Period.3",OBJPROP_YDISTANCE,25+Font.size*3);

      ObjectCreate("Period.4",OBJ_LABEL,0,0,0);
      ObjectSetText("Period.4",DoubleToStr(Period.4,0),Font.size,"Verdana",Font.colour);
      ObjectSet("Period.4",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Period.4",OBJPROP_XDISTANCE,230+ShiftX);
      ObjectSet("Period.4",OBJPROP_YDISTANCE,25+Font.size*3);
      
      ObjectCreate("Period.5",OBJ_LABEL,0,0,0);
      ObjectSetText("Period.5",DoubleToStr(Period.5,0),Font.size,"Verdana",Font.colour);
      ObjectSet("Period.5",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Period.5",OBJPROP_XDISTANCE,270+ShiftX);
      ObjectSet("Period.5",OBJPROP_YDISTANCE,25+Font.size*3);
            
      ObjectCreate("Moves",OBJ_LABEL,0,0,0);
      ObjectSetText("Moves",tLine2,Font.size,"Verdana",Font.colour);
      ObjectSet("Moves",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Moves",OBJPROP_XDISTANCE,5);
      ObjectSet("Moves",OBJPROP_YDISTANCE,20+Font.size*2);

      if (Move.1 > 0) Change.Colour=Change.Up.Colour;
      else if (Move.1 < 0) Change.Colour=Change.Down.Colour;
      else Change.Colour=Change.None.Colour;  
      ObjectCreate("Move.1",OBJ_LABEL,0,0,0);
      ObjectSetText("Move.1",DoubleToStr(Move.1,0),Font.size,"Verdana",Change.Colour);
      ObjectSet("Move.1",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Move.1",OBJPROP_XDISTANCE,110+ShiftX);
      ObjectSet("Move.1",OBJPROP_YDISTANCE,20+Font.size*2);

      if (Move.2 > 0) Change.Colour=Change.Up.Colour;
      else if (Move.2 < 0) Change.Colour=Change.Down.Colour;
      else Change.Colour=Change.None.Colour;  
      ObjectCreate("Move.2",OBJ_LABEL,0,0,0);
      ObjectSetText("Move.2",DoubleToStr(Move.2,0),Font.size,"Verdana",Change.Colour);
      ObjectSet("Move.2",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Move.2",OBJPROP_XDISTANCE,150+ShiftX);
      ObjectSet("Move.2",OBJPROP_YDISTANCE,20+Font.size*2);

      if (Move.3 > 0) Change.Colour=Change.Up.Colour;
      else if (Move.3 < 0) Change.Colour=Change.Down.Colour;
      else Change.Colour=Change.None.Colour;   
      ObjectCreate("Move.3",OBJ_LABEL,0,0,0);
      ObjectSetText("Move.3",DoubleToStr(Move.3,0),Font.size,"Verdana",Change.Colour);
      ObjectSet("Move.3",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Move.3",OBJPROP_XDISTANCE,190+ShiftX);
      ObjectSet("Move.3",OBJPROP_YDISTANCE,20+Font.size*2);

      if (Move.4 > 0) Change.Colour=Change.Up.Colour;
      else if (Move.4 < 0) Change.Colour=Change.Down.Colour;
      else Change.Colour=Change.None.Colour;  
      ObjectCreate("Move.4",OBJ_LABEL,0,0,0);
      ObjectSetText("Move.4",DoubleToStr(Move.4,0),Font.size,"Verdana",Change.Colour);
      ObjectSet("Move.4",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Move.4",OBJPROP_XDISTANCE,230+ShiftX);
      ObjectSet("Move.4",OBJPROP_YDISTANCE,20+Font.size*2);
      
      if (Move.5 > 0) Change.Colour=Change.Up.Colour;
      else if (Move.5 < 0) Change.Colour=Change.Down.Colour;
      else Change.Colour=Change.None.Colour;  
      ObjectCreate("Move.5",OBJ_LABEL,0,0,0);
      ObjectSetText("Move.5",DoubleToStr(Move.5,0),Font.size,"Verdana",Change.Colour);
      ObjectSet("Move.5",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Move.5",OBJPROP_XDISTANCE,270+ShiftX);
      ObjectSet("Move.5",OBJPROP_YDISTANCE,20+Font.size*2);
      
      ObjectCreate("BarRanges",OBJ_LABEL,0,0,0);
      ObjectSetText("BarRanges",tLine1,Font.size,"Verdana",Font.colour);
      ObjectSet("BarRanges",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("BarRanges",OBJPROP_XDISTANCE,5);
      ObjectSet("BarRanges",OBJPROP_YDISTANCE,15+Font.size);

      if (Range.1 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.1 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("BarRange.1",OBJ_LABEL,0,0,0);
      ObjectSetText("BarRange.1",DoubleToStr(Range.1,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("BarRange.1",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("BarRange.1",OBJPROP_XDISTANCE,110+ShiftX);
      ObjectSet("BarRange.1",OBJPROP_YDISTANCE,15+Font.size);

      if (Range.2 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.2 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("BarRange.2",OBJ_LABEL,0,0,0);
      ObjectSetText("BarRange.2",DoubleToStr(Range.2,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("BarRange.2",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("BarRange.2",OBJPROP_XDISTANCE,150+ShiftX);
      ObjectSet("BarRange.2",OBJPROP_YDISTANCE,15+Font.size);

      if (Range.3 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.3 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("BarRange.3",OBJ_LABEL,0,0,0);
      ObjectSetText("BarRange.3",DoubleToStr(Range.3,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("BarRange.3",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("BarRange.3",OBJPROP_XDISTANCE,190+ShiftX);
      ObjectSet("BarRange.3",OBJPROP_YDISTANCE,15+Font.size);

      if (Range.4 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.4 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("BarRange.4",OBJ_LABEL,0,0,0);
      ObjectSetText("BarRange.4",DoubleToStr(Range.4,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("BarRange.4",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("BarRange.4",OBJPROP_XDISTANCE,230+ShiftX);
      ObjectSet("BarRange.4",OBJPROP_YDISTANCE,15+Font.size);
      
      if (Range.5 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.5 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("BarRange.5",OBJ_LABEL,0,0,0);
      ObjectSetText("BarRange.5",DoubleToStr(Range.5,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("BarRange.5",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("BarRange.5",OBJPROP_XDISTANCE,270+ShiftX);
      ObjectSet("BarRange.5",OBJPROP_YDISTANCE,15+Font.size);
     
      ObjectCreate("Ranges",OBJ_LABEL,0,0,0);
      ObjectSetText("Ranges",tLine3,Font.size,"Verdana",Font.colour);
      ObjectSet("Ranges",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Ranges",OBJPROP_XDISTANCE,5);
      ObjectSet("Ranges",OBJPROP_YDISTANCE,10);
     
      if (Range.Period.1 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Period.1 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("Range.1",OBJ_LABEL,0,0,0);
      ObjectSetText("Range.1",DoubleToStr(Range.Period.1,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("Range.1",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Range.1",OBJPROP_XDISTANCE,110+ShiftX);
      ObjectSet("Range.1",OBJPROP_YDISTANCE,10);

      if (Range.Period.2 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Period.2 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("Range.2",OBJ_LABEL,0,0,0);
      ObjectSetText("Range.2",DoubleToStr(Range.Period.2,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("Range.2",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Range.2",OBJPROP_XDISTANCE,150+ShiftX);
      ObjectSet("Range.2",OBJPROP_YDISTANCE,10);

      if (Range.Period.3 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Period.3 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("Range.3",OBJ_LABEL,0,0,0);
      ObjectSetText("Range.3",DoubleToStr(Range.Period.3,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("Range.3",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Range.3",OBJPROP_XDISTANCE,190+ShiftX);
      ObjectSet("Range.3",OBJPROP_YDISTANCE,10);

      if (Range.Period.4 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Period.4 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("Range.4",OBJ_LABEL,0,0,0);
      ObjectSetText("Range.4",DoubleToStr(Range.Period.4,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("Range.4",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Range.4",OBJPROP_XDISTANCE,230+ShiftX);
      ObjectSet("Range.4",OBJPROP_YDISTANCE,10);
      
      if (Range.Period.5 >= Range.High)Range.Colour=Range.High.Colour;
      else if (Range.Period.5 <= Range.Low)Range.Colour=Range.Low.Colour;
      else Range.Colour=Range.Mid.Colour;      
      ObjectCreate("Range.5",OBJ_LABEL,0,0,0);
      ObjectSetText("Range.5",DoubleToStr(Range.Period.5,0),Font.size,"Verdana",Range.Colour);
      ObjectSet("Range.5",OBJPROP_CORNER,Corner.Of.Chart);
      ObjectSet("Range.5",OBJPROP_XDISTANCE,270+ShiftX);
      ObjectSet("Range.5",OBJPROP_YDISTANCE,10);
      
   return(0);
   }
//+------------------------------------------------------------------+